/* Problem URL: https://codeforces.com/group/YgJmumGtHD/contest/105936/problem/B */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    struct bar { 
        int x;
        int t;

        bool operator<(bar &b) {
            if (t == b.t) {
                return x > b.x;
            }
            return t > b.t;
        }
    };

    V<bar> fds(n);

    repv(i, fds) {
        cin >> i.x >> i.t;
    }

    sortv(fds);

    map<int, vi> var;

    rep(i, n) {
        var[fds[i].t].push_back(i);
    }

    vi dp(n, -1);
    vi maximal(n, 0);

    const int inf = INT32_MAX >> 1;

    function<int(int)> dfs = [&](int i) {
        if (dp[i] != -1) {
            return dp[i];
        }

        maximal[i] = fds[i].t;

        int t = fds[i].t;
        int x = fds[i].x;

        dp[i] = 1;

        auto end = var.find(t);

        auto itr = prev(var.end());

        int limit = inf;

        while (itr != end && itr->first < limit) {
            repv(j, itr->second) {
                if (abs(fds[j].x - x) + fds[i].t > fds[j].t) {
                    continue;
                }
                rmax(maximal[i], maximal[j]);
                rmax(dp[i], dfs(j) + 1);
            }
            rmin(limit, maximal[i]);

            if (itr->first <= limit) {
                itr--;
                continue;
            }

            itr = var.lower_bound(limit);
            if (itr != var.begin()) {
                itr--;
            }
        }

        return dp[i];
    };

    int ans = 0;

    rep(i, n) {
        rmax(ans, dfs(i));
    }

    cout << ans << '\n';
}
